; ##############################################################################
; ##############################################################################
; ##############################################################################
ENC_RX:
	ldi temp,(MODUL_RX)							; MODUL		
	STS(adr_MODUL_NR),temp
	call ENC_DATA_CLEAR
;-------------------------------------------------------------------------------
	LDS R0,(adr_ENC_RX_PAKET_COUNTER_ALLE_L)			; Counter	
	LDS R1,(adr_ENC_RX_PAKET_COUNTER_ALLE_H)
	add R0,EINS
	adc R1,NULL
	STS(adr_ENC_RX_PAKET_COUNTER_ALLE_L),R0
	STS(adr_ENC_RX_PAKET_COUNTER_ALLE_H),R1
;-------------------------------------------------------------------------------
; set the read pointer to the start of the received packet						
	ldi temp1,(ERDPTL)							; Read Pointer(L) 
	LDS temp2,(adr_ENC_RX_NEXT_READ_POINTER_L)
	call ENC_WCR_TEMP1_TEMP2					; INP: temp1(cod+addr) temp2(data)	
	ldi temp1,(ERDPTH)							; Read Pointer(H)
	LDS temp2,(adr_ENC_RX_NEXT_READ_POINTER_H)
	call ENC_WCR_TEMP1_TEMP2					; INP: temp1(cod+addr) temp2(data)	
;-------------------------------------------------------------------------------
	call SPI_CS_LOW								; CS auf LOW			
	ldi temp1,(RBM)								; Read Buffer Memory	
	call SPI_TX_TEMP1							; TX (Opcode+Address)	
;-------------------------------------------------------------------------------
	call SPI_RX_TEMP1							; Next Read Pointer(L) 	
	STS(adr_ENC_RX_NEXT_READ_POINTER_L),temp1
	call SPI_RX_TEMP1							; Next Read Pointer(H) 	
	STS(adr_ENC_RX_NEXT_READ_POINTER_H),temp1
	call SPI_RX_TEMP1							; length of the received frame(L)
	STS(adr_ENC_RX_FRAME_LENGTH_L),temp1
	call SPI_RX_TEMP1							; length of the received frame(H)
	STS(adr_ENC_RX_FRAME_LENGTH_H),temp1
	call SPI_RX_TEMP1							; RX-DUMMY (Status)				
	call SPI_RX_TEMP1							; RX-DUMMY (Status)				
;-------------------------------------------------------------------------------
; Nutzdaten (RX_FRAME_LENGTH) herausfiltern										
	LDS XL,(adr_ENC_RX_FRAME_LENGTH_L)			; X-Schleife					
	LDS XH,(adr_ENC_RX_FRAME_LENGTH_H)
	sbiw XL,4 									; -4
	STS(adr_ENC_RX_FRAME_LENGTH_L),XL			; X-Schleife					
	STS(adr_ENC_RX_FRAME_LENGTH_H),XH
;-------------------------------------------------------------------------------
; ERROR FRAME_LENGTH NULL ?														
	tst XL
	brne ENC_RX_NULL_OK
	tst XH
	brne ENC_RX_NULL_OK
	; Error						
	ldi temp,(ERROR_ENC_RX_NULL_FRAMELEN)
	call ERROR_SAVE_TEMP
ENC_RX_NULL_OK:
;-------------------------------------------------------------------------------
; ERROR FRAME_LENGTH MAX ?														
	cpi XH,HIGH(MAX_FRAMELEN)
	brlo ENC_RX_MAX_OK
	breq ENC_RX_MAX_w
	brsh ENC_RX_MAX_ERROR
ENC_RX_MAX_w:
	cpi XL,LOW (MAX_FRAMELEN)
	brlo ENC_RX_MAX_OK
	breq ENC_RX_MAX_OK
	brsh ENC_RX_MAX_ERROR
;-------------------------------------------------------------------------------
; Error																			
ENC_RX_MAX_ERROR:
	ldi temp,(ERROR_ENC_RX_MAX_FRAMELEN)
	call WARNUNG_SAVE_TEMP
ENC_RX_MAX_OK:
;-------------------------------------------------------------------------------
	ldi ZL,LOW (adr_ENC_DATA)					; Z-initialisieren				
	ldi ZH,HIGH(adr_ENC_DATA)	
ENC_RX_s:
	call SPI_RX_TEMP1							; RX DATA	
	ST Z+,temp1									; save SRAM	
	sbiw XL,1									; X-Schleife					
	tst XL
	brne ENC_RX_s	
	tst XH
	brne ENC_RX_s
;-------------------------------------------------------------------------------
	call SPI_RX_TEMP1	; RX-DUMMY (CRC)				
	call SPI_RX_TEMP1	; RX-DUMMY (CRC)				
	call SPI_RX_TEMP1	; RX-DUMMY (CRC)				
	call SPI_RX_TEMP1	; RX-DUMMY (CRC)				
	call SPI_CS_HIGH	; CS auf HIGH					
;-------------------------------------------------------------------------------
;move the rx read pointer to the start of the next received packet				
;this frees the memory we just read out											
	ldi temp1,(ERXRDPTL)					; RX RD Pointer(L) 
	LDS temp2,(adr_ENC_RX_NEXT_READ_POINTER_L)
	call ENC_WCR_TEMP1_TEMP2				; INP: temp1(cod+addr) temp2(data)	
	ldi temp1,(ERXRDPTH)					; RX RD Pointer(H)
	LDS temp2,(adr_ENC_RX_NEXT_READ_POINTER_H)
	call ENC_WCR_TEMP1_TEMP2				; INP: temp1(cod+addr) temp2(data)	
;-------------------------------------------------------------------------------
; decrement the packet counter indicate we are done with this packet			
	ldi temp1,(ECON2)	
	ldi temp2,(1<<Econ2_PKTDEC)
	call ENC_BFS_TEMP1_TEMP2				; INP: temp1(cod+addr) temp2(data)	
;-------------------------------------------------------------------------------
; DEBUGG																		
	LDS temp,(adr_DEBUG_RX_ON)
	tst temp
	breq ENC_RX_NO_DEBUGG 
	call DEBUG_ENC_RX
ENC_RX_NO_DEBUGG:
;-------------------------------------------------------------------------------
	call PROGRAMM_CHECK
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
ENC_RX_AUSWERTUNG:
	; PacketTyp (0x0806=ARP) ?					
	LDS temp1,(MacPacketTypL)
	LDS temp2,(MacPacketTypH)
	cpi temp1,LOW (MAC_PAKET_TYP_ARP)					;
	brne ENC_RX_AUSWERTUNG_NO_ARP
	cpi temp2,HIGH(MAC_PAKET_TYP_ARP)					;
	brne ENC_RX_AUSWERTUNG_NO_ARP
	; Counter ARP								
	LDS R0,(adr_ENC_RX_PAKET_COUNTER_ARP_L)
	LDS R1,(adr_ENC_RX_PAKET_COUNTER_ARP_H)
	add R0,EINS
	adc R1,NULL
	STS(adr_ENC_RX_PAKET_COUNTER_ARP_L),R0
	STS(adr_ENC_RX_PAKET_COUNTER_ARP_H),R1
	ldi temp,(MODUL_RX_ARP)						; MODUL		
	STS(adr_MODUL_NR),temp
	jmp ARP										; Sprung	
ENC_RX_AUSWERTUNG_NO_ARP:
;-------------------------------------------------------------------------------
	; PacketTyp (0x86DD=IPV6) ?					
	LDS temp1,(MacPacketTypL)
	LDS temp2,(MacPacketTypH)
	cpi temp1,LOW (MAC_PAKET_TYP_IPV6)					;
	brne ENC_RX_AUSWERTUNG_NO_IPV6
	cpi temp2,HIGH(MAC_PAKET_TYP_IPV6)					;
	brne ENC_RX_AUSWERTUNG_NO_IPV6
	; Counter IPv6							
	LDS R0,(adr_ENC_RX_PAKET_COUNTER_IPv6_L)
	LDS R1,(adr_ENC_RX_PAKET_COUNTER_IPv6_H)
	add R0,EINS
	adc R1,NULL
	STS(adr_ENC_RX_PAKET_COUNTER_IPv6_L),R0
	STS(adr_ENC_RX_PAKET_COUNTER_IPv6_H),R1
ENC_RX_AUSWERTUNG_NO_IPV6:
;-------------------------------------------------------------------------------
	; PacketTyp (0x0800=IP4) ? (DoD Standard Internet Protocol)					
ENC_RX_AUSWERTUNG_IP4:
	LDS temp1,(MacPacketTypL)
	LDS temp2,(MacPacketTypH)
	cpi temp1,LOW(MAC_PAKET_TYP_IPV4)
	brne ENC_RX_AUSWERTUNG_NO_IP4
	cpi temp2,HIGH(MAC_PAKET_TYP_IPV4)
	brne ENC_RX_AUSWERTUNG_NO_IP4
	LDS temp,(IP4VersionHeaderLength)
	cpi temp,0x45				;(0x45=20Bytes)
	brne ENC_RX_AUSWERTUNG_NO_IP4
	jmp ENC_RX_AUSWERTUNG_ICMP
;-------------------------------------------------------------------------------
ENC_RX_AUSWERTUNG_NO_IP4:
	LDS R0,(adr_ENC_RX_PAKET_COUNTER_NO_IPV4_L)
	LDS R1,(adr_ENC_RX_PAKET_COUNTER_NO_IPV4_H)
	add R0,EINS
	adc R1,NULL
	STS(adr_ENC_RX_PAKET_COUNTER_NO_IPV4_L),R0
	STS(adr_ENC_RX_PAKET_COUNTER_NO_IPV4_H),R1
	ret											; zurck	
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
ENC_RX_AUSWERTUNG_ICMP:
	; ICMP ?							
	LDS temp,(IP4ProtocolTyp)
	cpi temp,(IPv4_PROTOKOLL_TYP_ICMP)
	brne ENC_RX_AUSWERTUNG_NO_ICMP
	; Counter ICMP						
	LDS R0,(adr_ENC_RX_PAKET_COUNTER_ICMP_L)
	LDS R1,(adr_ENC_RX_PAKET_COUNTER_ICMP_H)
	add R0,EINS
	adc R1,NULL
	STS(adr_ENC_RX_PAKET_COUNTER_ICMP_L),R0
	STS(adr_ENC_RX_PAKET_COUNTER_ICMP_H),R1
	ldi temp,(MODUL_RX_ICMP)					; MODUL		
	STS(adr_MODUL_NR),temp
	jmp ICMP									; SPRUNG	
ENC_RX_AUSWERTUNG_NO_ICMP:
;-------------------------------------------------------------------------------
	; TCP ?								
	LDS temp,(IP4ProtocolTyp)
	cpi temp,(IPv4_PROTOKOLL_TYP_TCP)
	brne ENC_RX_AUSWERTUNG_NO_TCP
	; Counter TCP						
	LDS R0,(adr_ENC_RX_PAKET_COUNTER_TCP_L)
	LDS R1,(adr_ENC_RX_PAKET_COUNTER_TCP_H)
	add R0,EINS
	adc R1,NULL
	STS(adr_ENC_RX_PAKET_COUNTER_TCP_L),R0
	STS(adr_ENC_RX_PAKET_COUNTER_TCP_H),R1
	ldi temp,(MODUL_RX_TCP)							; MODUL		
	STS(adr_MODUL_NR),temp
	jmp TCP_RX											; SPRUNG	
ENC_RX_AUSWERTUNG_NO_TCP:
;-------------------------------------------------------------------------------
	; UDP ?								
	LDS temp,(IP4ProtocolTyp)
	cpi temp,(IPv4_PROTOKOLL_TYP_UDP)
	brne ENC_RX_AUSWERTUNG_NO_UDP
	; Counter UDP							
	LDS R0,(adr_ENC_RX_PAKET_COUNTER_UDP_L)
	LDS R1,(adr_ENC_RX_PAKET_COUNTER_UDP_H)
	add R0,EINS
	adc R1,NULL
	STS(adr_ENC_RX_PAKET_COUNTER_UDP_L),R0
	STS(adr_ENC_RX_PAKET_COUNTER_UDP_H),R1
	ldi temp,(MODUL_RX_UDP)							; MODUL		
	STS(adr_MODUL_NR),temp
	jmp UTP_RX
ENC_RX_AUSWERTUNG_NO_UDP:
;-------------------------------------------------------------------------------
	LDS R0,(adr_ENC_RX_PAKET_COUNTER_SONST_L)		; Counter	
	LDS R1,(adr_ENC_RX_PAKET_COUNTER_SONST_H)
	add R0,EINS
	adc R1,NULL
	STS(adr_ENC_RX_PAKET_COUNTER_SONST_L),R0
	STS(adr_ENC_RX_PAKET_COUNTER_SONST_H),R1
ret													; ZURCK	
; ##############################################################################
; ##############################################################################
; ##############################################################################

