; TCP															
.equ TCP_DATA_LENGTH_MAX	= 1400;100;1200;1400
; TCP-Flags														
.equ TCPflag_FIN	= 0; FIN Dieses Schlussflag (finish) dient zur Freigabe der Verbindung und zeigt an, dass keine Daten mehr vom Sender kommen. Die FIN- und SYN-Flags haben Sequenznummern, damit diese in der richtigen Reihenfolge abgearbeitet werden.
.equ TCPflag_SYN	= 1; SYN Pakete mit gesetztem SYN-Flag initiieren eine Verbindung. Der Server antwortet normalerweise entweder mit SYN+ACK, wenn er bereit ist, die Verbindung anzunehmen, andernfalls mit RST. Dient der Synchronisation von Sequenznummern beim Verbindungsaufbau (daher die Bezeichnung SYN).
.equ TCPflag_RESET	= 2; RST Das Reset-Flag wird verwendet, wenn eine Verbindung abgebrochen werden soll. Dies geschieht zum Beispiel bei technischen Problemen oder zur Abweisung unerwnschter Verbindungen (wie etwa nicht geffneten Ports, hier wird  anders als bei UDP  kein ICMP-Paket mit Port Unreachable verschickt).
.equ TCPflag_PUSH	= 3; PSH RFC 1122 und RFC 793 spezifizieren das Push-Flag so, dass bei gesetztem Flag sowohl der ausgehende, als auch der eingehende Puffer bergangen wird. Da man bei TCP keine Datagramme versendet, sondern einen Datenstrom hat, hilft das PSH-Flag, den Strom effizienter zu verarbeiten, da die empfangende Applikation so gezielter aufgeweckt werden kann und nicht bei jedem eintreffenden Datensegment feststellen muss, dass Teile der Daten noch nicht empfangen wurden, die aber ntig wren, um berhaupt weitermachen zu knnen.   Hilfreich ist dies, wenn man zum Beispiel bei einer Telnet-Sitzung einen Befehl an den Empfnger senden will. Wrde dieser Befehl erst im Puffer zwischengespeichert werden, so wrde dieser (stark) verzgert abgearbeitet werden.   Das PSH-Flag kann, abhngig von der TCP-Implementation im Verhalten zu obiger Erklrung abweichen.
.equ TCPflag_ACK	= 4; ACK  Das Acknowledgment-Flag hat in Verbindung mit der Acknowledgment-Nummer die Aufgabe, den Empfang von TCP-Segmenten beim Datentransfer zu besttigen. Die Acknowledgment-Nummer ist nur gltig, wenn das Flag gesetzt ist.
.equ TCPflag_URG	= 5; URG Ist das Urgent-Flag (urgent = dringend) gesetzt, so werden die Daten nach dem Header sofort von der Anwendung bearbeitet. Dabei unterbricht die Anwendung die Verarbeitung der Daten des aktuellen TCP-Segments und liest alle Bytes nach dem Header bis zu dem Byte, auf das das Urgent-Pointer-Feld zeigt, aus. Dieses Verfahren ist fern verwandt mit einem Softwareinterrupt. Dieses Flag kann zum Beispiel verwendet werden, um eine Anwendung auf dem Empfnger abzubrechen. Das Verfahren wird nur uerst selten benutzt, Beispiele sind die bevorzugte Behandlung von CTRL-C (Abbruch) bei einer Terminalverbindung ber rlogin oder telnet.    In der Regel wird dieses Flag nicht ausgewertet.
.equ TCPflag_ECN	= 6; CWR und ECE  sind zwei Flags, die fr Explicit Congestion Notification (ECN) bentigt werden. Mit gesetztem ECE-Bit (ECN-Echo) teilt der Empfnger dem Sender mit, dass das Netzwerk berlastet ist und die Senderate reduziert werden muss. Hat der Sender das getan, teilt er dies dem Empfnger durch Setzen des CWR-Bit (Congestion Window Reduced) mit.
.equ TCPflag_WCR	= 7; CWR und ECE  sind zwei Flags, die fr Explicit Congestion Notification (ECN) bentigt werden. Mit gesetztem ECE-Bit (ECN-Echo) teilt der Empfnger dem Sender mit, dass das Netzwerk berlastet ist und die Senderate reduziert werden muss. Hat der Sender das getan, teilt er dies dem Empfnger durch Setzen des CWR-Bit (Congestion Window Reduced) mit.

; PAKET_Typen (im MAC-HEADER)	https://de.wikipedia.org/wiki/Ethernet#Das_Typ-Feld_(EtherType)
.equ MAC_PAKET_TYP_ARP		= 0x0806
.equ MAC_PAKET_TYP_IPV4		= 0x0800
.equ MAC_PAKET_TYP_IPV6		= 0x86DD
; PROTOKOLL_Typen (IPv4) https://de.wikipedia.org/wiki/Protokoll_(IP)
.equ IPv4_PROTOKOLL_TYP_ICMP	= 1
.equ IPv4_PROTOKOLL_TYP_TCP		= 6
.equ IPv4_PROTOKOLL_TYP_UDP		= 17
; ICMP																		
.equ ICMP_ECHO_REPLY		= 0x00
.equ ICMP_ECHO_REQUEST		= 0x08
; Protokollaufbau (MAC-HEADER 14Bytes)										
.equ MAC_Header				= adr_ENC_DATA+0 	; !  
.equ DestinationMACaddr0	= adr_ENC_DATA+0														
.equ DestinationMACaddr1	= adr_ENC_DATA+1														
.equ DestinationMACaddr2	= adr_ENC_DATA+2														
.equ DestinationMACaddr3	= adr_ENC_DATA+3														
.equ DestinationMACaddr4	= adr_ENC_DATA+4														
.equ DestinationMACaddr5	= adr_ENC_DATA+5														
.equ SourceMACaddr0			= adr_ENC_DATA+6													
.equ SourceMACaddr1			= adr_ENC_DATA+7														
.equ SourceMACaddr2			= adr_ENC_DATA+8														
.equ SourceMACaddr3			= adr_ENC_DATA+9														
.equ SourceMACaddr4			= adr_ENC_DATA+10														
.equ SourceMACaddr5			= adr_ENC_DATA+11														
.equ MacPacketTypH			= adr_ENC_DATA+12	; 0x0806=ARP 
.equ MacPacketTypL			= adr_ENC_DATA+13															
;-------------------------------------------------------------------------------
; IP4-HEADER																	
.equ IP4_Header				= adr_ENC_DATA+14 	; !  
.equ IP4VersionHeaderLength	= adr_ENC_DATA+14 	;(0)	(0x45=20Bytes)
.equ IP4TOS 				= adr_ENC_DATA+15 	;(1)	
.equ IP4TotalLengthH 		= adr_ENC_DATA+16 	;(2)	
.equ IP4TotalLengthL		= adr_ENC_DATA+17 	;(3)	
.equ IP4IdentificationH 	= adr_ENC_DATA+18 	;(4)	
.equ IP4IdentificationL		= adr_ENC_DATA+19 	;(5)	
.equ IP4FlagsFragmentOffset0= adr_ENC_DATA+20 	;(6)	
.equ IP4FlagsFragmentOffset1= adr_ENC_DATA+21 	;(7)	
.equ IP4TimeToLive 			= adr_ENC_DATA+22 	;(8)	
.equ IP4ProtocolTyp			= adr_ENC_DATA+23 	;(9)	
.equ IP4HeaderChecksumH		= adr_ENC_DATA+24 	;(10)	
.equ IP4HeaderChecksumL 	= adr_ENC_DATA+25	;(11)	
.equ IP4SourceIPaddr3		= adr_ENC_DATA+26	;(12)	
.equ IP4SourceIPaddr2		= adr_ENC_DATA+27	;(13)	
.equ IP4SourceIPaddr1		= adr_ENC_DATA+28	;(14)	
.equ IP4SourceIPaddr0		= adr_ENC_DATA+29	;(15)	
.equ IP4DestinationIPaddr3 	= adr_ENC_DATA+30	;(16)	
.equ IP4DestinationIPaddr2 	= adr_ENC_DATA+31	;(17)	
.equ IP4DestinationIPaddr1 	= adr_ENC_DATA+32	;(18)	
.equ IP4DestinationIPaddr0 	= adr_ENC_DATA+33	;(19)	
;-------------------------------------------------------------------------------
; TCP (http://www.elektronik-kompendium.de/sites/net/0812271.htm)				
.equ TCP_Header				= adr_ENC_DATA+34 	; !  
.equ TCPsourcePortH			= adr_ENC_DATA+34	;(0) Hier steht der Quell-Port, von der die Anwendung das TCP-Paket verschickt. Bei einer Stellenanzahl von 16 Bit betrgt der hchste Port 65.535. 
.equ TCPsourcePortL			= adr_ENC_DATA+35	;(1) 
.equ TCPdestinationPortH	= adr_ENC_DATA+36	;(2) Hier steht der Ziel-Port, ber welchen das TCP-Paket der Anwendung zugestellt wird. Bei einer Stellenanzahl von 16 Bit betrgt der hchste Port 65.535. 
.equ TCPdestinationPortL	= adr_ENC_DATA+37	;(3) 
.equ TcpSeq3				= adr_ENC_DATA+38	;(4)Bei jeder TCP-Verbindung werden Nummern zwischen den Kommunikationspartner ausgehandelt. Whrend der Verbindung werden diese Nummern verwendet um die TCP-Pakete eindeutig zu identifizieren. 
.equ TcpSeq2				= adr_ENC_DATA+39	;(5) 
.equ TcpSeq1				= adr_ENC_DATA+40	;(6) 
.equ TcpSeq0				= adr_ENC_DATA+41	;(7) 
.equ TcpAck3				= adr_ENC_DATA+42	;(8)Alle Datenpakete werden besttigt. Dazu dient das ACK-Flag und die Acknowledgement-Nummer, die sich aus der Sequenz-Nummer und der Anzahl von empfangenen Bytes errechnet. Damit kann der Sender feststellen, ob die Daten beim Empfnger vollstndig angekommen sind. 
.equ TcpAck2				= adr_ENC_DATA+43	;(9) 
.equ TcpAck1				= adr_ENC_DATA+44	;(10)
.equ TcpAck0				= adr_ENC_DATA+45	;(11)
.equ TCPHeaderLength		= adr_ENC_DATA+46	;(12) Anzahl der 32-Bit-Blcke des TCP-Headers
.equ TCPflags				= adr_ENC_DATA+47	;(13) Kennzeichnung bestimmter fr die Kommunikation und Weiterverarbeitung der Daten wichtiger Zustnde (URG, ACK, PSH, RST, SYN, FIN). 
.equ TCPwindowSizeH			= adr_ENC_DATA+48	;(14) Der Empfnger sendet dem Sender in diesem Feld die Anzahl an Daten, die der Sender senden darf. Dadurch wird das berlaufen des Empfangspuffers beim Empfnger verhindert. Den Vorgang nennt man Windowing und dient der Datenflusssteuerung. 
.equ TCPwindowSizeL			= adr_ENC_DATA+49	;(15)
.equ TCPchecksumH			= adr_ENC_DATA+50	;(16) Dieses Feld dient der Kontrolle von Header- und Datenbereich. https://de.wikipedia.org/wiki/Transmission_Control_Protocol
.equ TCPchecksumL			= adr_ENC_DATA+51	;(17)
.equ TCPurgentPointerH		= adr_ENC_DATA+52	;(18) Zusammen mit der Sequenz-Nummer gibt dieser Wert die genaue Position der Daten im Datenstrom an. Der Wert ist nur gltig, wenn das URG-Flag gesetzt ist. 
.equ TCPurgentPointerL		= adr_ENC_DATA+53	;(19)
.equ TCPdata				= adr_ENC_DATA+54	;(20)
;-------------------------------------------------------------------------------
; UDP																			
.equ UDP_Header				= adr_ENC_DATA+34 	; !  
.equ UDPSourcePortH			= adr_ENC_DATA+34
.equ UDPSourcePortL			= adr_ENC_DATA+35
.equ UDPDestinationPortH	= adr_ENC_DATA+36
.equ UDPDestinationPortL	= adr_ENC_DATA+37
.equ UDPLengthH				= adr_ENC_DATA+38
.equ UDPLengthL				= adr_ENC_DATA+39
.equ UDPChecksumH			= adr_ENC_DATA+40
.equ UDPChecksumL			= adr_ENC_DATA+41
.equ UDPdata				= adr_ENC_DATA+42
;-------------------------------------------------------------------------------
; ICMP																			
.equ ICMP_Header			= adr_ENC_DATA+34 	; !  
.equ ICMPtype				= adr_ENC_DATA+34
.equ ICMPcode				= adr_ENC_DATA+35
.equ ICMPchecksumH			= adr_ENC_DATA+36
.equ ICMPchecksumL			= adr_ENC_DATA+37
.equ ICMPidentifferH		= adr_ENC_DATA+38
.equ ICMPidentifferL		= adr_ENC_DATA+39
.equ ICMPsequencenumberH	= adr_ENC_DATA+40
.equ ICMPsequencenumberL	= adr_ENC_DATA+41
.equ ICMPdata				= adr_ENC_DATA+42
;-------------------------------------------------------------------------------
; Protokollaufbau (ARP-HEADER)													
.equ ARP_Header				= adr_ENC_DATA+14 	; !  
.equ ARPhwtypeH				= adr_ENC_DATA+14	; 0x0001 	
.equ ARPhwtypeL				= adr_ENC_DATA+15
.equ ARPprotokollTypH		= adr_ENC_DATA+16	; 0x0800 	
.equ ARPprotokollTypL		= adr_ENC_DATA+17															
.equ ARPhardwareLen			= adr_ENC_DATA+18	; 0x06		
.equ ARPprotokollLen		= adr_ENC_DATA+19	; 0x04		
.equ ARPoperationCodeH		= adr_ENC_DATA+20	; 0x0001=Request 0x0002=Reply	
.equ ARPoperationCodeL		= adr_ENC_DATA+21															
.equ ARPsenderMACaddr0		= adr_ENC_DATA+22															
.equ ARPsenderMACaddr1		= adr_ENC_DATA+23															
.equ ARPsenderMACaddr2		= adr_ENC_DATA+24															
.equ ARPsenderMACaddr3		= adr_ENC_DATA+25															
.equ ARPsenderMACaddr4		= adr_ENC_DATA+26															
.equ ARPsenderMACaddr5		= adr_ENC_DATA+27															
.equ ARPsenderIPAddr0		= adr_ENC_DATA+28															
.equ ARPsenderIPAddr1		= adr_ENC_DATA+29															
.equ ARPsenderIPAddr2		= adr_ENC_DATA+30															
.equ ARPsenderIPAddr3		= adr_ENC_DATA+31															
.equ ARPtargetsHardAddr0	= adr_ENC_DATA+32														
.equ ARPtargetsHardAddr1	= adr_ENC_DATA+33														
.equ ARPtargetsHardAddr2	= adr_ENC_DATA+34														
.equ ARPtargetsHardAddr3	= adr_ENC_DATA+35														
.equ ARPtargetsHardAddr4	= adr_ENC_DATA+36														
.equ ARPtargetsHardAddr5	= adr_ENC_DATA+37														
.equ ARPtargetsIPAddr0 		= adr_ENC_DATA+38															
.equ ARPtargetsIPAddr1 		= adr_ENC_DATA+39															
.equ ARPtargetsIPAddr2 		= adr_ENC_DATA+40															
.equ ARPtargetsIPAddr3		= adr_ENC_DATA+41

;Bedeutung der Felder im TCP-Header
;Feldinhalt	Bit	Beschreibung
;Quell-Port (Source-Port)	16 	Hier steht der Quell-Port, von der die Anwendung das TCP-Paket verschickt. Bei einer Stellenanzahl von 16 Bit betrgt der hchste Port 65.535.
;Ziel-Port(Destination-Port)	16 	Hier steht der Ziel-Port, ber welchen das TCP-Paket der Anwendung zugestellt wird. Bei einer Stellenanzahl von 16 Bit betrgt der hchste Port 65.535.
;Sequenz-Nummer	32 	Bei jeder TCP-Verbindung werden Nummern zwischen den Kommunikationspartner ausgehandelt. Whrend der Verbindung werden diese Nummern verwendet um die TCP-Pakete eindeutig zu identifizieren.
;Acknowledgement-Nummer	32 	Alle Datenpakete werden besttigt. Dazu dient das ACK-Flag und die Acknowledgement-Nummer, die sich aus der Sequenz-Nummer und der Anzahl von empfangenen Bytes errechnet. Damit kann der Sender feststellen, ob die Daten beim Empfnger vollstndig angekommen sind.
;Data Offset	4 	Hier steht die Anzahl der 32-Bit-Blcke des TCP-Headers. Die Mindestmenge betrgt 5.
;			Data Offset: Anzahl der 32 BIT Worte, aus denen der TCP Header besteht. Das Data Offset zeigt daher an, ab wo die ersten Daten in diesem Segment stehen. Das Feld ist 4 BIT gro, da heit der TCP Header kann maximal 15*32 BIT= 60 Byte lang sein. Da der normale Teil des TCP Header immer 20 Byte gro ist, kann der optionale Teil 40 Byte lang sein.
;Reserviert	6 	Dieser Bereich ist auf 000000 gesetzt und fr Erweiterungen des TCP-Headers gedacht.
;Flags 	6 	Kennzeichnung bestimmter fr die Kommunikation und Weiterverarbeitung der Daten wichtiger Zustnde (URG, ACK, PSH, RST, SYN, FIN).
;Window-Gre	16 	Der Empfnger sendet dem Sender in diesem Feld die Anzahl an Daten, die der Sender senden darf. Dadurch wird das berlaufen des Empfangspuffers beim Empfnger verhindert. Den Vorgang nennt man Windowing und dient der Datenflusssteuerung.
;Check-Summe	16 	Dieses Feld dient der Kontrolle von Header- und Datenbereich.
;Urgent-Pointer	16 	Zusammen mit der Sequenz-Nummer gibt dieser Wert die genaue Position der Daten im Datenstrom an. Der Wert ist nur gltig, wenn das URG-Flag gesetzt ist.
;Optionen/Fllbits(Options/Padding), jeweils 32 Bit lang 	Dieses Feld beinhaltet optionale Informationen. Um die 32-Bit-Grenze einzuhalten wird das Options-Feld mit Nullen aufgefllt.

;Der Algorithmus fr die Bildung der Prfsumme ist einfach: 
;alle 16-Bit Wrter werden im 1er-Komplement addiert und die Summe ermittelt. 
;Bei der Berechnung ist das Feld Checksum auf Null gesetzt und das Datenfeld wird bei ungerader Lnge um ein Nullbyte aufgefllt. 
;Fhrt der Empfnger des Segments die Berechnung auf das gesamte Segment aus - inklusive des Feldes fr die Prfsumme - sollte das Ergebnis 0 sein [Ta96]. 
;Der Pseudo-Header enthlt die 32-bit groen IP-Adressen der Quell- und Zielmaschine sowie die Protokollnummer (fr TCP 6) und die Lnge des TCP-Segments. 
;Die Einbeziehung der Felder des Pseudo-Headers in die Prfsummenberechnung hilft, durch IP falsch zugeteilte Pakete zu erkennen. 
;Die Verwendung von IP-Adressen auf der Transportebene stellt allerdings eine Verletzung der Protokollhierarchie dar.
