; ##############################################################################
; ##############################################################################
; ##############################################################################
ARP:
;-------------------------------------------------------------------------------
	; OPERATION CODE (0x0001) Request (Anforderung)
	LDS temp1,(ARPoperationCodeL)
	LDS temp2,(ARPoperationCodeH)
	cpi temp1,LOW(0x0001)
	brne ARP_NO_REQUEST
	cpi temp2,HIGH(0x0001)
	brne ARP_NO_REQUEST
	rjmp ARP_RX_REQUEST		; RX ARP REQUEST		
ARP_NO_REQUEST:
;-------------------------------------------------------------------------------
	; OPERATION CODE (0x0002) REPLY 				
	LDS temp1,(ARPoperationCodeL)
	LDS temp2,(ARPoperationCodeH)
	cpi temp1,LOW(0x0002)
	brne ARP_NO_REPLY
	cpi temp2,HIGH(0x0002)
	brne ARP_NO_REPLY
	rjmp ARP_CHACHE_EINTRAG	; RX ARP REPLAY(Antwort)			
;-------------------------------------------------------------------------------
ARP_NO_REPLY:
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ARP REQUEST(Anforderung) empfangen											
ARP_RX_REQUEST:
	; ist es meine IP-ADRESSE ?
	call FUNCTION_IP_EIGENE_NACH_TEMP1_4
	LDS temp5,(ARPTargetsIPAddr0)	; DATA 
	LDS temp6,(ARPTargetsIPAddr1)	; DATA 
	LDS temp7,(ARPTargetsIPAddr2)	; DATA 
	LDS temp8,(ARPTargetsIPAddr3)	; DATA 
	; Vergleich					
	cp temp1,temp5
	brne ARP_REQUEST_NO
	cp temp2,temp6
	brne ARP_REQUEST_NO
	cp temp3,temp7
	brne ARP_REQUEST_NO
	cp temp4,temp8
	brne ARP_REQUEST_NO
	jmp ARP_REQUEST_REPLAY
;-------------------------------------------------------------------------------
ARP_REQUEST_NO:
	ret
;-------------------------------------------------------------------------------
; ARP-REPLAY zurcksenden														
ARP_REQUEST_REPLAY:
	; ARP_CHACHE_EINTRAG						
	call ARP_CHACHE_EINTRAG
	; MAC_HEADER_ADRESS_TAUSCH					
	call MAKE_MAC_NEW_HEADER
	; ARPsenderMACaddr nach ARPtargetsHardAddr	
	LDS temp1,(ARPsenderMACaddr0)
	LDS temp2,(ARPsenderMACaddr1)
	LDS temp3,(ARPsenderMACaddr2)
	LDS temp4,(ARPsenderMACaddr3)
	LDS temp5,(ARPsenderMACaddr4)
	LDS temp6,(ARPsenderMACaddr5)
	STS(ARPtargetsHardAddr0),temp1
	STS(ARPtargetsHardAddr1),temp2
	STS(ARPtargetsHardAddr2),temp3
	STS(ARPtargetsHardAddr3),temp4
	STS(ARPtargetsHardAddr4),temp5
	STS(ARPtargetsHardAddr5),temp6
	; ARPsenderIPAddr nach ARPtargetsIPAddr		
	LDS temp1,(ARPsenderIPAddr0)
	LDS temp2,(ARPsenderIPAddr1)
	LDS temp3,(ARPsenderIPAddr2)
	LDS temp4,(ARPsenderIPAddr3)
	STS(ARPtargetsIPAddr0),temp1
	STS(ARPtargetsIPAddr1),temp2
	STS(ARPtargetsIPAddr2),temp3
	STS(ARPtargetsIPAddr3),temp4
;-------------------------------------------------------------------------------
	; Operation Code 			
	ldi temp1,LOW (0x0002)
	ldi temp2,HIGH(0x0002)
	STS(ARPoperationCodeL),temp1
	STS(ARPoperationCodeH),temp2
	; ARPsenderMACaddr
	call FUNCTION_MAC_EIGENE_NACH_TEMP1_6
	STS(ARPsenderMACaddr0),temp1
	STS(ARPsenderMACaddr1),temp2
	STS(ARPsenderMACaddr2),temp3
	STS(ARPsenderMACaddr3),temp4
	STS(ARPsenderMACaddr4),temp5
	STS(ARPsenderMACaddr5),temp6
	; ARPsenderIPAddr
	call FUNCTION_IP_EIGENE_NACH_TEMP1_4
	STS(ARPsenderIPAddr0),temp1
	STS(ARPsenderIPAddr1),temp2
	STS(ARPsenderIPAddr2),temp3
	STS(ARPsenderIPAddr3),temp4
;-------------------------------------------------------------------------------
	; Anzahl Bytes 				
	ldi temp1,LOW (42)	; ohne Controlwort	
	ldi temp2,HIGH(42)
	STS(adr_ENC_TX_FRAME_LENGTH_L),temp1
	STS(adr_ENC_TX_FRAME_LENGTH_H),temp2
	jmp ENC_TX
; ##############################################################################
; ##############################################################################
; ##############################################################################
ARP_TX_REQUEST_ROUTER:
	LED_ARP_OFF
	LDS temp1,(adr_IP_ROUTER0)
	LDS temp2,(adr_IP_ROUTER1)
	LDS temp3,(adr_IP_ROUTER2)
	LDS temp4,(adr_IP_ROUTER3)
	rjmp ARP_TX_REQUEST_TEMP1_4
; ##############################################################################
; ##############################################################################
; ##############################################################################
ARP_TX_REQUEST_SCAN:
	LDS temp,(adr_ARP_SCAN_ON)
	tst temp
	brne ARP_TX_REQUEST_SCAN_RUN
	ret
;-------------------------------------------------------------------------------
ARP_TX_REQUEST_SCAN_RUN:
	LDS temp1,(adr_IP_ROUTER0)
	LDS temp2,(adr_IP_ROUTER1)
	LDS temp3,(adr_IP_ROUTER2)
	LDS temp4,(adr_ARP_SCAN_NR)
	inc temp4
	STS(adr_ARP_SCAN_NR),temp4
	cpi temp4,0					; NULL berspringen	
	breq ARP_TX_REQUEST_SCAN_RUN
	rjmp ARP_TX_REQUEST_TEMP1_4
; ##############################################################################
; ##############################################################################
; ##############################################################################
ARP_TX_REQUEST_TEMP1_4:
	push temp1
	push temp2
	push temp3
	push temp4
	; DESTINATION-Adress								
	STS(DestinationMACaddr0),VOLL
	STS(DestinationMACaddr1),VOLL
	STS(DestinationMACaddr2),VOLL
	STS(DestinationMACaddr3),VOLL
	STS(DestinationMACaddr4),VOLL
	STS(DestinationMACaddr5),VOLL
	; SOURCE-Adress 			
	LDS temp1,(adr_MAC0)
	LDS temp2,(adr_MAC1)
	LDS temp3,(adr_MAC2)
	LDS temp4,(adr_MAC3)
	LDS temp5,(adr_MAC4)
	LDS temp6,(adr_MAC5)
	STS(SourceMACaddr0),temp1
	STS(SourceMACaddr1),temp2
	STS(SourceMACaddr2),temp3
	STS(SourceMACaddr3),temp4
	STS(SourceMACaddr4),temp5
	STS(SourceMACaddr5),temp6
	; TYPE (0x0806)				
	ldi temp1,LOW (0x0806)
	ldi temp2,HIGH(0x0806)
	STS(MacPacketTypL),temp1
	STS(MacPacketTypH),temp2
;-------------------------------------------------------------------------------
	; Hardaware TYPE (0x0001)	
	ldi temp1,LOW (0x0001)
	ldi temp2,HIGH(0x0001)
	STS(ARPhwtypeL),temp1
	STS(ARPhwtypeH),temp2
	; Protokoll TYPE (0x0800)	
	ldi temp1,LOW (0x0800)
	ldi temp2,HIGH(0x0800)
	STS(ARPprotokollTypL),temp1
	STS(ARPprotokollTypH),temp2
	; Lengt Harware Adress (06)	
	ldi temp1,0x06
	STS(ARPhardwareLen),temp1
	; Lengt Protokoll Adress (04)
	ldi temp1,0x04
	STS(ARPprotokollLen),temp1
	; Operation Code 0x0001=Request 0x0002=Reply				
	ldi temp1,LOW (0x0001)
	ldi temp2,HIGH(0x0001)
	STS(ARPoperationCodeL),temp1
	STS(ARPoperationCodeH),temp2
	; Sender Harware Adress	
	call FUNCTION_MAC_EIGENE_NACH_TEMP1_6; MAC-eigene			
	STS(ARPsenderMACaddr0),temp1
	STS(ARPsenderMACaddr1),temp2
	STS(ARPsenderMACaddr2),temp3
	STS(ARPsenderMACaddr3),temp4
	STS(ARPsenderMACaddr4),temp5
	STS(ARPsenderMACaddr5),temp6
	; Sender IP Adress		
	call FUNCTION_IP_EIGENE_NACH_TEMP1_4 ; IP-eigene	
	STS(ARPsenderIPAddr0),temp1
	STS(ARPsenderIPAddr1),temp2
	STS(ARPsenderIPAddr2),temp3
	STS(ARPsenderIPAddr3),temp4
	; Target  Harware Adress
	STS(ARPtargetsHardAddr0),NULL
	STS(ARPtargetsHardAddr1),NULL
	STS(ARPtargetsHardAddr2),NULL
	STS(ARPtargetsHardAddr3),NULL
	STS(ARPtargetsHardAddr4),NULL
	STS(ARPtargetsHardAddr5),NULL
	; Target  IP Adress		
	pop temp4
	pop temp3
	pop temp2
	pop temp1
	STS(ARPtargetsIPAddr0),temp1
	STS(ARPtargetsIPAddr1),temp2
	STS(ARPtargetsIPAddr2),temp3
	STS(ARPtargetsIPAddr3),temp4
	; Anzahl Bytes 			
	ldi temp1,LOW (42)
	ldi temp2,HIGH(42)
	STS(adr_ENC_TX_FRAME_LENGTH_L),temp1
	STS(adr_ENC_TX_FRAME_LENGTH_H),temp2
	jmp ENC_TX
; ##############################################################################
; ##############################################################################
; ##############################################################################
ARP_CHACHE_EINTRAG:
	LDS temp1,(ARPsenderIPAddr0)	; IP	
	LDS temp2,(ARPsenderIPAddr1)
	LDS temp3,(ARPsenderIPAddr2)
	LDS temp4,(ARPsenderIPAddr3)

	LDS temp5,(adr_IP_ROUTER0)
	LDS temp6,(adr_IP_ROUTER1)
	LDS temp7,(adr_IP_ROUTER2)
	LDS temp8,(adr_IP_ROUTER3)

	cp temp1,temp5
	brne ARP_CHACHE_EINTRAG_START
	cp temp2,temp6
	brne ARP_CHACHE_EINTRAG_START
	cp temp3,temp7
	brne ARP_CHACHE_EINTRAG_START
	cp temp4,temp8
	brne ARP_CHACHE_EINTRAG_START
;-------------------------------------------------------------------------------
	LDS temp1,(ARPsenderMACaddr0)
	LDS temp2,(ARPsenderMACaddr1)
	LDS temp3,(ARPsenderMACaddr2)
	LDS temp4,(ARPsenderMACaddr3)
	LDS temp5,(ARPsenderMACaddr4)
	LDS temp6,(ARPsenderMACaddr5)
	STS(adr_MAC_ROUTER0),temp1		; MAC-Router
	STS(adr_MAC_ROUTER1),temp2
	STS(adr_MAC_ROUTER2),temp3
	STS(adr_MAC_ROUTER3),temp4
	STS(adr_MAC_ROUTER4),temp5
	STS(adr_MAC_ROUTER5),temp6
	LED_ARP_ON
;-------------------------------------------------------------------------------
; Anzahl begrenzen																
ARP_CHACHE_EINTRAG_START:
	LDS temp,(adr_ARP_CHACHE_ANZAHL); ANZAHL-Eintrge	
	cpi temp,(30)					; max	
	brlo ARP_CHACHE_EINTRAG_RUN
	ret
;-------------------------------------------------------------------------------
ARP_CHACHE_EINTRAG_RUN:
	LDS temp1,(ARPsenderIPAddr0)	; IP	
	LDS temp2,(ARPsenderIPAddr1)
	LDS temp3,(ARPsenderIPAddr2)
	LDS temp4,(ARPsenderIPAddr3)
	ldi ZL,LOW (adr_ARP_CHACHE_DATA); INITIALISIERUNG
	ldi ZH,HIGH(adr_ARP_CHACHE_DATA)
;-------------------------------------------------------------------------------
ARP_CHACHE_EINTRAG_READ_NEXT_DATENSATZ:
	LD temp5,Z+						; IP	
	LD temp6,Z+
	LD temp7,Z+
	LD temp8,Z+
	adiw ZL,8						; +8
;-------------------------------------------------------------------------------
	; IP=0.0.0.0					
	tst temp5
	brne ARP_CHACHE_EINTRAG_NO_NULL
	tst temp6
	brne ARP_CHACHE_EINTRAG_NO_NULL
	tst temp7
	brne ARP_CHACHE_EINTRAG_NO_NULL
	tst temp8
	brne ARP_CHACHE_EINTRAG_NO_NULL
	; WRITE DATENSATZ			
	sbiw ZL,12					;-12		
	LDS temp,(ARPsenderIPAddr0)	; IP		
	ST Z+,temp
	LDS temp,(ARPsenderIPAddr1)
	ST Z+,temp
	LDS temp,(ARPsenderIPAddr2)
	ST Z+,temp
	LDS temp,(ARPsenderIPAddr3)
	ST Z+,temp
	LDS temp,(SourceMACaddr0)	; MAC		
	ST Z+,temp
	LDS temp,(SourceMACaddr1)
	ST Z+,temp
	LDS temp,(SourceMACaddr2)
	ST Z+,temp
	LDS temp,(SourceMACaddr3)
	ST Z+,temp
	LDS temp,(SourceMACaddr4)
	ST Z+,temp
	LDS temp,(SourceMACaddr5)
	ST Z+,temp
	ST Z+,NULL					; RESERVE	
	ST Z+,NULL					; RESERVE	
	; ANZAHL-Eintrge			
	LDS temp,(adr_ARP_CHACHE_ANZAHL)
	inc temp
	STS(adr_ARP_CHACHE_ANZAHL),temp
	ret
ARP_CHACHE_EINTRAG_NO_NULL:
;-------------------------------------------------------------------------------
	; DATENSATZ schon vorhanden ?
	cp temp1,temp5
	brne ARP_CHACHE_EINTRAG_READ_NEXT_DATENSATZ
	cp temp2,temp6
	brne ARP_CHACHE_EINTRAG_READ_NEXT_DATENSATZ
	cp temp3,temp7
	brne ARP_CHACHE_EINTRAG_READ_NEXT_DATENSATZ
	cp temp4,temp8
	brne ARP_CHACHE_EINTRAG_READ_NEXT_DATENSATZ
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################

