; ##############################################################################
; ##############################################################################
; ##############################################################################
TCP_CONNECT:
	ldi temp,(ZEIT_PORT_TCP) ;10s
	STS(adr_TCP_PORT_OPEN),temp
	call TCP_CONNECT_RUN		; TX						
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
TCP_CONNECT_RUN:

;-------------------------------------------------------------------------------
	call MAKE_MAC_HEADER_ROUTER_TYP_DOD
;-------------------------------------------------------------------------------
	call MAKE_IP4_VersionHeaderLength45
	call MAKE_IP4_TOS_NULL
	call MAKE_IP4_TOTAL_LENGTH_48BYTES
	call MAKE_IP4_IDENTIFIKATION
	call MAKE_IP4_FlagsFragmentOffset_Dont_Fragment
	call MAKE_IP4_TimeToLive
	call MAKE_IP4_PROTOKOLL_TYP_TCP
	call MAKE_IP4_IP_EIGENE_NACH_IP4SourceIP
;-------------------------------------------------------------------------------
	LDS temp1,(adr_IP_SERVER_EXTERN0)
	LDS temp2,(adr_IP_SERVER_EXTERN1)
	LDS temp3,(adr_IP_SERVER_EXTERN2)
	LDS temp4,(adr_IP_SERVER_EXTERN3)
	STS(IP4DestinationIPaddr3),temp1
	STS(IP4DestinationIPaddr2),temp2
	STS(IP4DestinationIPaddr1),temp3
	STS(IP4DestinationIPaddr0),temp4
;===============================================================================
;===============================================================================
	LDS temp1,(adr_EXTERN_TCP_PORT_L)
	LDS temp2,(adr_EXTERN_TCP_PORT_H)
	STS(TCPsourcePortH),temp2
	STS(TCPsourcePortL),temp1
;-------------------------------------------------------------------------------
	LDS temp1,(adr_EXTERN_TCP_PORT_DEST_L)
	LDS temp2,(adr_EXTERN_TCP_PORT_DEST_H)
	STS(TCPdestinationPortH),temp2
	STS(TCPdestinationPortL),temp1
;-------------------------------------------------------------------------------
	ldi temp4,BYTE4(10000)
	ldi temp3,BYTE3(10000)
	ldi temp2,BYTE2(10000)
	ldi temp1,BYTE1(10000)
	STS(TcpSeq3),temp4
	STS(TcpSeq2),temp3
	STS(TcpSeq1),temp2
	STS(TcpSeq0),temp1
;-------------------------------------------------------------------------------
	STS(TcpAck3),NULL
	STS(TcpAck2),NULL
	STS(TcpAck1),NULL
	STS(TcpAck0),NULL
;-------------------------------------------------------------------------------
	call MAKE_TCP_HEADER_LENGTH_28BYTES
	call MAKE_TCP_FLAG_SYN
;-------------------------------------------------------------------------------
	ldi temp2,HIGH(65535)
	ldi temp1,LOW (65535)
	STS(TCPwindowSizeH),temp2	; Window size value: 65535
	STS(TCPwindowSizeL),temp1
;-------------------------------------------------------------------------------
	STS(TCPurgentPointerH),NULL	; Urgent pointer: 0
	STS(TCPurgentPointerL),NULL
;-------------------------------------------------------------------------------
;-------------------------------------------------------------------------------
	ldi temp,0x02			; Kind: Maximum Segment Size (2)
	STS(TCPdata+0),temp
;-------------------------------------------------------------------------------
	ldi temp,0x04			; Length: 4
	STS(TCPdata+1),temp
;-------------------------------------------------------------------------------
	ldi temp2,HIGH(1460)
	ldi temp1,LOW (1460)
	STS(TCPdata+2),temp2	; MSS Value: 1460
	STS(TCPdata+3),temp1
;-------------------------------------------------------------------------------
	ldi temp,0x01			; No-Operation (NOP)
	STS(TCPdata+4),temp
;-------------------------------------------------------------------------------
	ldi temp,0x01			; No-Operation (NOP)
	STS(TCPdata+5),temp
;-------------------------------------------------------------------------------
	ldi temp,0x04			; Kind: SACK Permitted (4)
	STS(TCPdata+6),temp
;-------------------------------------------------------------------------------
	ldi temp,0x02			; Length: 2
	STS(TCPdata+7),temp
;-------------------------------------------------------------------------------
	jmp TCP_TX_PAKET
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ACK=SEQ+1																		
; TX: ACK 																		
TCP_TX_ACK:
	call MAKE_TCP_FLAG_ACK
	call MAKE_IP4_TOTAL_LENGTH_40BYTES
	call MAKE_TCP_HEADER_LENGTH_20BYTES
	call MAKE_TCP_TAUSCH_SEQ_ACK_PLUS	; !
;-------------------------------------------------------------------------------
	call MAKE_MAC_TAUSCH_MAC
	call MAKE_IP4_TAUSCH_IP
	call MAKE_TCP_TAUSCH_PORT
	call MAKE_IP4_IDENTIFIKATION
;-------------------------------------------------------------------------------
	jmp TCP_TX_PAKET
; ##############################################################################
; ##############################################################################
; ##############################################################################
; RX: FIN+ACK																	
; TX: ACK 																		
; dann																			
; TX: FIN 																		
TCP_TX_ACK_FIN:
	call MAKE_TCP_FLAG_ACK
	call MAKE_IP4_TOTAL_LENGTH_40BYTES
	call MAKE_TCP_HEADER_LENGTH_20BYTES
	call MAKE_TCP_TAUSCH_SEQ_ACK_PLUS
;-------------------------------------------------------------------------------
	call MAKE_MAC_TAUSCH_MAC
	call MAKE_IP4_TAUSCH_IP
	call MAKE_TCP_TAUSCH_PORT
	call MAKE_IP4_IDENTIFIKATION
;-------------------------------------------------------------------------------
	call TCP_TX_PAKET
;-------------------------------------------------------------------------------
;-------------------------------------------------------------------------------
	call WAIT_10ms
	call MAKE_TCP_FLAG_FIN_ACK
	jmp TCP_TX_PAKET
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
TCP_TX_PAKET:
	call MAKE_IP4_TimeToLive
	call MAKE_IP4_HEADER_CHECKSUM
	call MAKE_TCP_PSEUDOHEADER_CHECKSUM
	call MAKE_ENC_TX_FRAME_LENGTH
	jmp ENC_TX
; ##############################################################################
; ##############################################################################
; ##############################################################################
; Alle Daten im SRAM (adr_TCP_STACK) senden.									
;																				
; INP: (adr_TCP_STACK_LENGTH)													
;																				
TCP_TX_DATA:
	; Initialisierung				
	STS(adr_TCP_STACK_SEQ_LENGTH_L),NULL	; SEQ_Length	
	STS(adr_TCP_STACK_SEQ_LENGTH_H),NULL
	STS(adr_TCP_PAKET_COUNTER),NULL
	STS(adr_TCP_STACK_ZEIGER_L),NULL		; ZEIGER		
	STS(adr_TCP_STACK_ZEIGER_H),NULL
;-------------------------------------------------------------------------------
TCP_TX_DATA_NEW_PAKET:
	STS(adr_TCP_STACK_PAKET_LENGTH_L),NULL	; PAKET_LENGTH
	STS(adr_TCP_STACK_PAKET_LENGTH_H),NULL

	ldi XL,LOW (TCPdata)					;(X) TCPdata	
	ldi XH,HIGH(TCPdata)

	ldi ZL,LOW (adr_TCP_STACK)				;(Z) TCP_STACK	
	ldi ZH,HIGH(adr_TCP_STACK)	
	LDS temp1,(adr_TCP_STACK_ZEIGER_L)		; ZEIGER		
	LDS temp2,(adr_TCP_STACK_ZEIGER_H)
	add ZL,temp1
	adc ZH,temp2

	ldi YL,LOW (TCP_DATA_LENGTH_MAX)		;(Y) Schleife	
	ldi YH,HIGH(TCP_DATA_LENGTH_MAX)
;-------------------------------------------------------------------------------
; DATEN vom TCP_STACK nach TCPdata kopieren										
TCP_TX_DATA_NEW_BYTE:
	LD temp,Z+								;(Z) TCP_STACK			
	ST X+,temp								;(X) TCPdata			

	LDS temp1,(adr_TCP_STACK_PAKET_LENGTH_L); PAKET_LENGTH			
	LDS temp2,(adr_TCP_STACK_PAKET_LENGTH_H)
	add temp1,EINS							; PAKET_LENGTH			
	adc temp2,NULL
	STS(adr_TCP_STACK_PAKET_LENGTH_L),temp1	; PAKET_LENGTH			
	STS(adr_TCP_STACK_PAKET_LENGTH_H),temp2

	LDS temp1,(adr_TCP_STACK_ZEIGER_L)		; ZEIGER				
	LDS temp2,(adr_TCP_STACK_ZEIGER_H)
	add temp1,EINS							; ZEIGER +1				
	adc temp2,NULL
	STS(adr_TCP_STACK_ZEIGER_L),temp1		; ZEIGER				
	STS(adr_TCP_STACK_ZEIGER_H),temp2

	LDS temp,(adr_TCP_STACK_LENGTH_L)		; ZEIGER-ENDE erreicht ?
	cp temp,temp1						
	brne TCP_TX_DATA_w						; nein					
	LDS temp,(adr_TCP_STACK_LENGTH_H)		; ZEIGER-ENDE erreicht ?
	cp temp,temp2
	brne TCP_TX_DATA_w						; nein					
	jmp TCP_TX_DATA_PAKET					; ja					
;-------------------------------------------------------------------------------
TCP_TX_DATA_w:
	sbiw YL,1								;(Y) Schleife			
	tst YL									;(Y) ENDE erreicht ?	
	brne TCP_TX_DATA_NEW_BYTE
	tst YH									;(Y) ENDE erreicht ?	
	brne TCP_TX_DATA_NEW_BYTE
	call TCP_TX_DATA_PAKET
	rjmp TCP_TX_DATA_NEW_PAKET
; ##############################################################################
; ##############################################################################
; ##############################################################################
; Ein TCP-PAKET senden															
TCP_TX_DATA_PAKET:
	; PAKET_COUNTER						
	LDS temp,(adr_TCP_PAKET_COUNTER)
	inc temp
	STS(adr_TCP_PAKET_COUNTER),temp
;-------------------------------------------------------------------------------
	; SEQ=SEQ+(adr_TCP_STACK_SEQ_LENGTH)
	LDS temp1,(TcpSeq0)
	LDS temp2,(TcpSeq1)
	LDS temp3,(TcpSeq2)
	LDS temp4,(TcpSeq3)
	LDS temp5,(adr_TCP_STACK_SEQ_LENGTH_L)
	LDS temp6,(adr_TCP_STACK_SEQ_LENGTH_H)
	add temp1,temp5
	adc temp2,temp6
	adc temp3,NULL
	adc temp4,NULL
	STS(TcpSeq0),temp1
	STS(TcpSeq1),temp2
	STS(TcpSeq2),temp3
	STS(TcpSeq3),temp4
;-------------------------------------------------------------------------------
	; IPv4 Total Length				
	LDS ZL,(adr_TCP_STACK_PAKET_LENGTH_L)
	LDS ZH,(adr_TCP_STACK_PAKET_LENGTH_H)
	adiw ZL,(40)							; 40=20(IPv4-Header)+20(TCP-Header)
	STS(IP4TotalLengthL),ZL
	STS(IP4TotalLengthH),ZH
;-------------------------------------------------------------------------------
	call MAKE_TCP_FLAG_PUSH_ACK				; TCP-FLAG-PUSH-ACK				
	call MAKE_TCP_HEADER_LENGTH_20BYTES		; TCP-HeaderLength				
	call TCP_TX_PAKET
;-------------------------------------------------------------------------------
	LDS temp1,(adr_TCP_STACK_PAKET_LENGTH_L)
	LDS temp2,(adr_TCP_STACK_PAKET_LENGTH_H)
	STS(adr_TCP_STACK_SEQ_LENGTH_L),temp1
	STS(adr_TCP_STACK_SEQ_LENGTH_H),temp2
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
