; ##############################################################################
; ##############################################################################
; ##############################################################################
UTP_DNS_ZEITSERVER:
	ldi ZH, high(DNS_ZEITSERVER*2)	; TABELLE
	ldi ZL,  low(DNS_ZEITSERVER*2)
	rjmp UTP_TX_DNS_Z
; ##############################################################################
; ##############################################################################
; ##############################################################################
UTP_DNS_SERVER_EXTERN:
	call FUNCTION_IP_SERVER_EXTERN_NULL_CHECK_C ; IP=0.0.0.0 ---> C=1	
	brcs UTP_DNS_SERVER_EXTERN_RUN
	ret
;-------------------------------------------------------------------------------
UTP_DNS_SERVER_EXTERN_RUN:
	ldi ZH, high(DNS_CHECKIP*2)	; TABELLE
	ldi ZL,  low(DNS_CHECKIP*2)
	call FUNCTION_IP_SERVER_EXTERN_NULL
	rjmp UTP_TX_DNS_Z
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
UTP_TX_DNS_Z:
	ldi temp,(ZEIT_PORT_UDP) ;10s
	STS(adr_UDP_PORT_OPEN),temp
;-------------------------------------------------------------------------------
	call ENC_DATA_CLEAR
	call MAKE_MAC_HEADER_ROUTER_TYP_DOD
	call MAKE_IP4_VersionHeaderLength45
	call MAKE_IP4_TOS_NULL
	call MAKE_IP4_IDENTIFIKATION
	call MAKE_IP4_FlagsFragmentOffset_NULL
	call MAKE_IP4_TimeToLive
	call MAKE_IP4_PROTOKOLL_TYP_UDP
	call MAKE_IP4_IP_EIGENE_NACH_IP4SourceIP
	call MAKE_IP4_IP_ROUTER_NACH_IP4DestinationIP
;-------------------------------------------------------------------------------
; UDP-HEADER																	
;-------------------------------------------------------------------------------
	ldi temp2,0xce
	ldi temp1,0x4e
	STS(UDPSourcePortH),temp2
	STS(UDPSourcePortL),temp1
;-------------------------------------------------------------------------------
	ldi temp2,0x00
	ldi temp1,0x35
	STS(UDPDestinationPortH),temp2
	STS(UDPDestinationPortL),temp1
;-------------------------------------------------------------------------------
	STS(UDPLengthH),NULL
	STS(UDPLengthL),NULL
;-------------------------------------------------------------------------------
	STS(UDPChecksumH),NULL
	STS(UDPChecksumL),NULL
;-------------------------------------------------------------------------------
; DNS-DATEN																		
;-------------------------------------------------------------------------------
	ldi XL,low (UDPdata)	; X-initalisieren
	ldi XH,high(UDPdata)
	ldi temp2,high(12000)
	ldi temp1,low (12000)
	ST X+,temp2				; Transaktion-ID	
	ST X+,temp1				; Transaktion-ID	
	ST X+,EINS				; Flags				
	ST X+,NULL				; Flags				
	ST X+,NULL				; Questions (Fragen)
	ST X+,EINS				; Questions (Fragen)
	ST X+,NULL				; Ansver (Antworten)
	ST X+,NULL				; Ansver (Antworten)
	ST X+,NULL				; Authority RRs		
	ST X+,NULL				; Authority RRs		
	ST X+,NULL				; Additional RRs	
	ST X+,NULL				; Additional RRs	
;-------------------------------------------------------------------------------
; DNS-URL aus Tabelle bernehmen												
;-------------------------------------------------------------------------------
	ST X+,VOLL				; '.' einpflegen	
UTP_DNS_URL_s:
	LPM temp,Z+
	cpi temp,0
	breq UTP_DNS_URL_w
	ST X+,temp
	rjmp UTP_DNS_URL_s
UTP_DNS_URL_w:
;-------------------------------------------------------------------------------
; DNS-URL aus Tabelle bereinigen												
;-------------------------------------------------------------------------------
	ldi ZL,low (UDPdata+12)
	ldi ZH,high(UDPdata+12)
	mov YL,ZL				; Merker
	mov YH,ZH
	adiw ZL,1
	clr temp1
;-------------------------------------------------------------------------------
UTP_DNS_URL_s1:
	LD temp,Z
	cpi temp,'.'
	breq UTP_DNS_URL_TREFFER
	tst temp
	breq UTP_DNS_URL_FERTIG
	inc temp1				; Counter +1	
	adiw ZL,1
	rjmp UTP_DNS_URL_s1
;-------------------------------------------------------------------------------
UTP_DNS_URL_TREFFER:
	ST Y,temp1				; Counter write	
	mov YL,ZL				; Merker		
	mov YH,ZH
	adiw ZL,1
	clr temp1
	rjmp UTP_DNS_URL_s1
;-------------------------------------------------------------------------------
UTP_DNS_URL_FERTIG:
	ST Y,temp1				; Counter write	
;-------------------------------------------------------------------------------
; DNS-DATEN																		
;-------------------------------------------------------------------------------
	ST X+,NULL				; Platzhaler				
	ST X+,NULL				; Type: A (Host Address) (1)
	ST X+,EINS				; Type: A (Host Address) (1)
	ST X+,NULL				; Class: IN (0x0001)		
	ST X+,EINS				; Class: IN (0x0001)		
;-------------------------------------------------------------------------------
;-------------------------------------------------------------------------------
;-------------------------------------------------------------------------------
	mov temp1,XL
	mov temp2,XH
	ldi temp3,low (UDP_Header)
	ldi temp4,high(UDP_Header)
	sub temp1,temp3
	sbc temp2,temp4
	STS(UDPLengthL),temp1
	STS(UDPLengthH),temp2
;-------------------------------------------------------------------------------
	mov temp1,XL
	mov temp2,XH
	ldi temp3,low (IP4_HEADER)
	ldi temp4,high(IP4_HEADER)
	sub temp1,temp3
	sbc temp2,temp4
	STS(IP4TotalLengthL),temp1
	STS(IP4TotalLengthH),temp2
;-------------------------------------------------------------------------------
	call MAKE_IP4_HEADER_CHECKSUM
	call MAKE_ENC_TX_FRAME_LENGTH
	jmp ENC_TX
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
UTP_RX:
	LDS temp,(adr_DEBUG_RX_UDP_ON)
	tst temp
	breq UTP_RX_NO_DEBUG
	call DEBUG_ENC_RX
UTP_RX_NO_DEBUG:
;-------------------------------------------------------------------------------
	call FUNCTION_IP_EIGENE_NACH_TEMP1_4
	LDS temp,(IP4DestinationIPaddr3)	
	cp  temp,temp1
	brne UTP_RX_EXIT
	LDS temp,(IP4DestinationIPaddr2)	
	cp  temp,temp2
	brne UTP_RX_EXIT
	LDS temp,(IP4DestinationIPaddr1)	
	cp  temp,temp3
	brne UTP_RX_EXIT
	LDS temp,(IP4DestinationIPaddr0)
	cp  temp,temp4
	breq UTP_RX_w
UTP_RX_EXIT:
	ret
;-------------------------------------------------------------------------------
UTP_RX_w:
	LDS temp,(adr_UDP_PORT_OPEN)	
	tst temp
	brne UTP_RX_RUN
	LDS XL,(adr_FW_ANGRIFFE_UTP_L)
	LDS XH,(adr_FW_ANGRIFFE_UTP_H)
	adiw XL,1
	STS(adr_FW_ANGRIFFE_UTP_L),XL
	STS(adr_FW_ANGRIFFE_UTP_H),XH
	ret
;-------------------------------------------------------------------------------
UTP_RX_RUN:
	ldi temp,(ZEIT_PORT_CLOSE)
	STS(adr_UDP_PORT_OPEN),temp
	LED_ONLINE_ON
	ldi ZL,low (UDPdata)
	ldi ZH,HIGH(UDPdata)
	LDS temp1,(UDPLengthL)
	LDS temp2,(UDPLengthH)
	add ZL,temp1
	adc ZH,temp2
	subi ZL,8+4
;-------------------------------------------------------------------------------
	LD temp1,Z+
	STS(adr_IP_SERVER_EXTERN0),temp1
	LD temp2,Z+
	STS(adr_IP_SERVER_EXTERN1),temp2
	LD temp3,Z+
	STS(adr_IP_SERVER_EXTERN2),temp3
	LD temp4,Z+
	STS(adr_IP_SERVER_EXTERN3),temp4
;-------------------------------------------------------------------------------
;	LDS temp1,(UDPdata+7)	
;	LDS temp2,(UDPdata+6)	
;	call ZAHL_TEMP1_2		
	call ZEILE2
	call UTP_DNS_ANZEIGE_URL
	call WAIT_500ms
	call LCD_CLEAR
	LED_ONLINE_OFF
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
UTP_DNS_ANZEIGE_URL:
	ldi ZL,low (UDPdata+12+1)
	ldi ZH,high(UDPdata+12+1)
	ldi temp9,16	; Scleife
UTP_DNS_ANZEIGE_s:
	LD temp,Z+
	tst temp	; ende
 	breq UTP_DNS_ANZEIGE_FERTIG
	dec temp9	; schleife
	breq  UTP_DNS_ANZEIGE_FERTIG
	cpi temp,30; Sonderzeichen
	brsh UTP_DNS_ANZEIGE_w
	ldi temp,'.'
UTP_DNS_ANZEIGE_w:
	call LCD_DATA_TEMP
	rjmp UTP_DNS_ANZEIGE_s
UTP_DNS_ANZEIGE_FERTIG:
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################





